#include "lpc210x.h"
#include <math.h>
#include "glcd.h"
#include "glcdpaint.h"

void LCD_SetPixel(unsigned int ptr, unsigned char x, unsigned char y)
{
	LCD_SetAddrPtr(ptr+(GRAPHIC_BYTESPERROW*y)+(x/BITPERBYTE));
	LCD_Send('c',BITSETRESET|BITSET|(BITPERBYTE-1-(x%BITPERBYTE)));
}

void LCD_ClearPixel(unsigned int ptr, unsigned char x, unsigned char y)
{
	LCD_SetAddrPtr(ptr+(GRAPHIC_BYTESPERROW*y)+(x/BITPERBYTE));
	LCD_Send('c',BITSETRESET|BITRESET|(BITPERBYTE-1-(x%BITPERBYTE)));
}

void LCD_Pixel(unsigned int ptr, unsigned char x, unsigned char y, unsigned char color)
{
	if (color==0) 
		LCD_ClearPixel(ptr,x,y);
	else
		LCD_SetPixel(ptr,x,y);
}
  
void LCD_Line(unsigned int ptr,int x1,int y1,int x2,int y2, unsigned char color)
{
 	double i,j,steigung;
 	int tmp;
	unsigned char inv;

	if (y1==y2){
                for (tmp=x1; tmp<=x2; tmp++) LCD_Pixel(ptr,tmp,y1,color);
                return;
        }
        if (x1==x2){
                for (tmp=y1; tmp<=y2; tmp++) LCD_Pixel(ptr,x1,tmp,color);
                return;
        }

        if (fabs(y2-y1)>fabs(x2-x1))
        {
                inv=1;
                tmp=y1; y1=x1; x1=tmp;
                tmp=y2; y2=x2; x2=tmp;
        }
        else
                inv=0;

        if ((x2-x1)==0)
                steigung=0;
        else
	        steigung=((float)(y2-y1))/((float)(x2-x1));

	if (x2<x1)
	{
		tmp=y1; y1=y2; y2=tmp;
		tmp=x1; x1=x2; x2=tmp;
	}
        for (i=0; i<=x2-x1; i++)
	{
                j=(y1+((i)*steigung))+0.5;
		if (inv==0)
                 	LCD_Pixel(ptr,i+x1,j,color);
		else
                 	LCD_Pixel(ptr,j,i+x1,color);
	}
}

void LCD_Rectangle(unsigned int ptr,unsigned char x1,unsigned char y1,unsigned char x2,unsigned char y2, unsigned char color)
{
	LCD_Line(ptr,x1,y1,x1,y2,color);
	LCD_Line(ptr,x1,y1,x2,y1,color);
	LCD_Line(ptr,x2,y1,x2,y2,color);
	LCD_Line(ptr,x1,y2,x2,y2,color);
}

void LCD_FilledRectangle(unsigned int ptr,unsigned char x1,unsigned char y1,unsigned char x2,unsigned char y2, unsigned char color)
{
	unsigned char i,sbyte;
	int sbit;
	unsigned char chg;

	if(x2<x1){
		chg=x1;
		x1=x2;
		x2=chg;
	}
	if(y2<y1){
		chg=y1;
		y1=y2;
		y2=chg;
	}
	for(i=0;i<GRAPHIC_BYTESPERROW;i++){
		if(color)
			linebuf[i]=0;
		else
			linebuf[i]=0xFF;
	}
	for(sbyte=0;sbyte<GRAPHIC_BYTESPERROW;sbyte++){
		for(sbit=(BITPERBYTE-1);sbit>=0;sbit--){
			if(((BITPERBYTE*sbyte)+((BITPERBYTE-1)-sbit))>=x1 && ((BITPERBYTE*sbyte)+((BITPERBYTE-1)-sbit))<=x2){ 
				if(color) 
					linebuf[sbyte]|=1<<sbit; 
				else 
					linebuf[sbyte]&=255-(1<<sbit);
			}
		}
	}
	for(i=y1;i<=y2;i++)
		if(color)
			LCD_ModLine(ptr+(i*GRAPHIC_BYTESPERROW),GRAPHIC_BYTESPERROW,'o'); 
		else 
			LCD_ModLine(ptr+(i*GRAPHIC_BYTESPERROW),GRAPHIC_BYTESPERROW,'a'); 
}
