#ifndef GLCDPAINT_H
#define GLCDPAINT_H



/*
 * 	Set/Clear Pixel
 * 	ptr:
 * 	16-bit Page Pointer
 * 	x:
 * 	X-Achse
 * 	y:
 * 	Y-Achse
 */
void LCD_SetPixel(unsigned int ptr, unsigned char x, unsigned char y);
void LCD_ClearPixel(unsigned int ptr, unsigned char x, unsigned char y);
void LCD_Pixel(unsigned int ptr, unsigned char x, unsigned char y, unsigned char color);

/*
 *	Draw Line
 *	ptr:
 *	16-bit Page Pointer
 *	x1/y1:
 *	Startpoint
 *	x2/y2:
 *	Stoppoint
 *	color:
 *	0	clr
 *	sonst	set
 */
void LCD_Line(unsigned int ptr,int x1,int y1,int x2,int y2, unsigned char color);

/*
 * 	Draw Rectangle
 * 	ptr:
 * 	16-bit Page Pointer
 * 	x1/y1:
 * 	Startpointer
 * 	(upper-left)
 * 	X2/y2:
 * 	Stoppointer
 * 	(lower-right)
 * 	color:
 * 	0	clr
 * 	sonst	set
 */
void LCD_Rectangle(unsigned int ptr,unsigned char x1,unsigned char y1,unsigned char x2,unsigned char y2, unsigned char color);

/*
 *	FAST
 * 
 * 	Draw/Clear Area
 * 	ptr:
 * 	16-bit Page Pointer
 * 	x1/y1:
 * 	Spartpointer
 * 	(upper-left)
 * 	x2/y2:
 * 	Stoppointer
 * 	(lower-left)
 * 	color:
 * 	0	clr
 * 	sonst	set
 */
void LCD_FilledRectangle(unsigned int ptr,unsigned char x1,unsigned char y1,unsigned char x2,unsigned char y2, unsigned char color);

#endif
