#include "lpc210x.h"
#include "system.h"


void SYSTEM_Init(void)
{
	//Remap Interrupt Vectors to SRAM
	MEMMAP = 2;

	//MAM fully enabled
	MAMCR = 0;
	MAMTIM = 3;
	MAMCR = 2;

	//enable PLL
	PLLCFG = MSEL | (1<<PSEL1) | (0<<PSEL0);
	PLLCON = PLLCON_PLLE;
	PLLFEED = 0xAA;
	PLLFEED = 0x55;
	// wait for PLL lock
	while (!(PLLSTAT & PLLSTAT_LOCK));
	// enable & connect PLL
	PLLCON = PLLCON_PLLE | PLLCON_PLLC;
	PLLFEED = 0xAA;
	PLLFEED = 0x55;

	// set VPB speed
	VPBDIV = VPBDIV_VAL;

	VICIntEnClr = 0xFFFFFFFF;           		// clear all interrupts
	VICIntSelect = 0x00000000;            		// clear all FIQ selections
	//VICDefVectAddr = (unsigned int)reset;     	// point unvectored IRQs to reset()


}
