#include "lpc210x.h"
#include "system.h"
#include "uart.h"
#include "glcd.h"
//#include "glcdpaint.h"
//#include "glcdprintf.h"

#ifndef BIT
#define BIT(n)              (1 << (n))
#endif

#define LEDMASK 0xFFFFFFFF

unsigned int graphicptr;
unsigned int textptr;


void udelay(int val){
      int d = val*69;
      while(d--);
}

void chgptr(void)
{
	if(graphicptr==GP0)
	{
		graphicptr=GP1;
		textptr=TP1;
	} else {
		graphicptr=GP0;
		textptr=TP0;
	}
}

void view(void)
{
	LCD_SetHomePtr('t',textptr);
	LCD_SetHomePtr('g',graphicptr);
}

void LCD_String(unsigned int ptrin, unsigned char row, unsigned char column,char *buf){
	unsigned char loop=0;
	LCD_SetAddrPtr(ptrin+(row*GRAPHIC_BYTESPERROW)+column);
	while(buf[loop]!=0){
		switch(buf[loop]){
		case '':
			LCD_SendData(0x64);
			break;
		case '':
			LCD_SendData(0x6E);
			break;
		case '':
			LCD_SendData(0x74);
			break;
		case '':
			LCD_SendData(0x79);
			break;
		case '':
			LCD_SendData(0x7A);
			break;
		case '':
			LCD_SendData(0x81);
			break;
		case '':
			LCD_SendData(0x80);
			break;
		default:
			LCD_SendData(buf[loop]-0x20);
		}
		loop++;
	}
}



int main(void)
{
	int i,buf;
	unsigned char data=0;


	SYSTEM_Init();


	PINSEL0=5;
	PINSEL1=0;

	IODIR |= LEDMASK;
//	IOSET = LEDMASK;

	UART_0Init(B115200, UART_8N1, UART_FIFO_1);

UART_0Putch('S');

	graphicptr=GP0;
	textptr=TP0;
	LCD_Init();
	LCD_SetHomePtr('t',TP0);
	LCD_SetHomePtr('g',GP0);
	LCD_ClearRam(0,0x1C00);
	//LCD_Rectangle(GP0,13,20,118,42,1);
	LCD_String(TP0,3,3,"   ARM rockt!   ");
	LCD_String(TP0,4,3,"by Jrgen Eckert");


	LCDIODATA_OUT;
	while(1)
	{

		for(i=0;i<10;i++)
      			udelay(1000);
		IOCLR |= (1<<19);
		for(i=0;i<10;i++)
      			udelay(1000);
		IOSET |= (1<<19);
  	}
  return(0);
}


